""" mgoal.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import whrandom
from goal import goal
from mind import *

#goals
def is_suitable_place_for_home(self):
    count=len(self.mem.recall_place(self.get_xyz(),100.0))
    return count==0

def find_place(self):
    "find place for home: wander randomly"
    (x,y,z)=self.get_xyz()
    r=lambda :whrandom.uniform(-50,50)
    return [event("move",what=self,loc=(x+r(),y+r(),z+r()))]

find_place_for_home=goal("find place for home not too near or far from others",
                         is_suitable_place_for_home,[find_place])

def build_home(self):
    #CHEAT!: this will only start home building: need goal for this (same for axe)
    #actually use goals for everything
    self.personal_knowledge.xyz["home"]=self.get_xyz()
    return [event("make",what="house", what_desc="home", loc=self.get_xyz())]

def have_home(self):
    "Do I have home?"
    return self.things.has_key('house')

find_home=goal("find place for home and build it",have_home,
               [find_place_for_home,build_home])
