""" map.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
from types import *
from thing import thing

class map:
    def __init__(self):
        self.things={}
    def make_thing_from_event(self, e):
        t=thing(e.what)
        et=e.what
        t.id=et.id
        t.name=et.name
        t.type=et.type
        if type(e.loc)==TupleType:
            t.xyz=e.loc
        else:
            t.place=self.things[e.loc]
        self.things[t.id]=t
        return t
